# Capture Enemy Ships

import App
import MissionLib
import Bridge.BridgeUtils
import Lib.Ambiguity
import QuickBattle.QuickBattle
import Custom.QuickBattleGame.QuickBattle

pBridge = App.g_kSetManager.GetSet('bridge')
g_pBrex = App.CharacterClass_GetObject(pBridge, 'Engineer')
pBrexMenu = Bridge.BridgeUtils.GetBridgeMenu('Engineer')
ET_CAPTURE = App.Mission_GetNextEventType()

def Capture(pObject, pEvent):
	pPlayer = MissionLib.GetPlayer()
	pTarget = pPlayer.GetTarget()
	pSet = pPlayer.GetContainingSet()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pEnemies = pMission.GetEnemyGroup()
        pFriendlies = pMission.GetFriendlyGroup()
        dist = 300
	pClosest = None
	lpEnemies = pEnemies.GetActiveObjectTupleInSet(pSet)
	
        for pObject in lpEnemies:
		pEnemy = App.ShipClass_Cast(pObject)
		d = Custom.QuickBattleGame.QuickBattle.Distance(pEnemy)
		if (d<dist) and (pEnemy.GetName() != pPlayer.GetName()) and pEnemy.GetImpulseEngineSubsystem() != None:
			pClosest = pEnemy
			dist = d
	
        # try to find an offline Shield
        pTargetattr = App.ShipClass_Cast(pTarget)
        if (pTargetattr.GetShields() != None): 
                if (pTargetattr.GetShields().GetCurShields(App.ShieldClass.FRONT_SHIELDS) < 200): 
                        print ("Front Shield is Offline...beaming") 
                elif (pTargetattr.GetShields().GetCurShields(App.ShieldClass.REAR_SHIELDS) < 200): 
                        print ("After Shield is Offline...beaming") 
                elif (pTargetattr.GetShields().GetCurShields(App.ShieldClass.TOP_SHIELDS) < 200): 
                        print ("Top Shield is Offline...beaming") 
                elif (pTargetattr.GetShields().GetCurShields(App.ShieldClass.BOTTOM_SHIELDS) < 200): 
                        print ("Bottom Shield is Offline...beaming") 
                elif (pTargetattr.GetShields().GetCurShields(App.ShieldClass.LEFT_SHIELDS) < 200): 
                        print ("Left Shield is Offline...beaming") 
                elif (pTargetattr.GetShields().GetCurShields(App.ShieldClass.RIGHT_SHIELDS) < 200): 
                        print ("Right Shield is Offline...beaming") 
                else:
                        print ("No offline Shield...sorry") 
                        return 
        
        PlayerMarines = pPlayer.GetHull().GetRadius() * 50
        EnemyMarines = pTargetattr.GetHull().GetRadius() * 50
        
        print("Beaming", PlayerMarines, "Marines over, fighting against", EnemyMarines, "Enemies")
        
        
        # Fight here
        if (FightBattle(PlayerMarines, EnemyMarines) == 0):
            print("We...actually Lost.")
            return
        print("Well - we won!")
        # else continue
        # so we won the fight - make Target friendly:
        pFriendlies.AddName(pTarget.GetName())
        MarinesSetFriendlyAI(pTarget)

    
def FightBattle(PlayerMarines, EnemyMarines):
        cWin    = PlayerMarines / EnemyMarines * 100
        cRandom = App.g_kSystemWrapper.GetRandomNumber(100)
        print("Fight ratio is:", cWin, "%")
        print("Random number is:", cRandom)
        if (cRandom > cWin):
            return 0
        return 1


def MarinesSetFriendlyAI(pTarget):
	import QuickBattle.QuickBattle
	import Custom.QuickBattleGame.QuickBattle

        pTargetattr = App.ShipClass_Cast(pTarget)
	# set AI
	# We need to know if we are playing normal QB or QBR:
	# QB
	if QuickBattle.QuickBattle.pFriendlies:
		if (pTargetattr.GetShipProperty().IsStationary() == 1):
			# its a Station
			import QuickBattle.StarbaseFriendlyAI
			pTargetattr.SetAI(QuickBattle.StarbaseFriendlyAI.CreateAI(pTargetattr))
		else:
			import QuickBattle.QuickBattleFriendlyAI
			pTargetattr.SetAI(QuickBattle.QuickBattleFriendlyAI.CreateAI(pTargetattr))
	# QBR
	elif Custom.QuickBattleGame.QuickBattle.pFriendlies:
		if (pTargetattr.GetShipProperty().IsStationary() == 1):
			# its a Station
			import Custom.QuickBattleGame.StarbaseFriendlyAI
			pTargetattr.SetAI(Custom.QuickBattleGame.StarbaseFriendlyAI.CreateAI(pTargetattr))
		else:
			import Custom.QuickBattleGame.QuickBattleFriendlyAI
			pTargetattr.SetAI(Custom.QuickBattleGame.QuickBattleFriendlyAI.CreateAI(pTargetattr))


if (pBrexMenu != None):
	event = Lib.Ambiguity.getEvent("ET_CAPTURE")
	g_pBrex.AddPythonFuncHandlerForInstance(event, __name__ + ".Capture")
	pButton = QuickBattle.QuickBattle.CreateBridgeMenuButton(App.TGString('Capture'), event, 0, g_pBrex)
	pBrexMenu.PrependChild(pButton)
